#ifndef CONSTANT_H
#define CONSTANT_H

#define MBASE	0x10000000	/* MBAR Base Address */
#define ADRBASE	0x00020000	/* ADRAM Base address */
#define ADREND	0x0002FFFF	/* ADRAM End address */
#define PAR		0x0CA		/* Pin Assignment Registers offset address */
#define PPDDR	0x1C5		/* Parallel Port Direction Register offset address */
#define PPDAT	0x1C9		/* Parallel Port Data Registers (PP0-PP7) offset address */

#endif