#include "io.h"
#include "devboard.h"

char* pfpointer= (char*) (ADRBASE+1);
char* pDir = (char*) (MBASE+PPDDR);
char* pData = (char*) (MBASE+PPDAT);
char* pAddr;

void fresetfp()
{
	pfpointer = (char*) (ADRBASE+1);
}

int fopen_rbf( char* argv, char* mode)
{
	char* pAddr;

	int mark = 0;
	int count;
	int max;
	
	max = ADREND+1-ADRBASE;
	
	pAddr = (char*) ADRBASE;
	
	for(count=0x0;count<max;count++)
	{
		if(count==0x0)
		{
			if(*pAddr!=((char)0xCA))
			{
				Result(1);
				return 0;
			}	
		}	
		
		if(mark)
		{
			if(*pAddr==((char)0x35))
			{
				/*Result(0);*/
				return (count);
			}
			
			mark = 0;
		}
		
		if(*pAddr==((char)0x53))
			mark = 1;
								
		pAddr++;
	}
	
	Result(1);
	return 0;
}

int fseek_rbf( int finputid, int start, int end )
{
	int seek_position = 0;

	seek_position = fgetsize();

	return (seek_position?0:1);
}

int ftell_rbf( int finputid )
{
	int filesize = 0;
	
	filesize = fgetsize();

	return filesize;
}

int fgetsize()
{
	char* pAddr;
	int max;
	int mark = 0;
	int done = 0;
	int count = 0;
	
	max = ADREND+1-ADRBASE;
	
	for(count=0x0;count<max;count++)
	{
		pAddr = (char*) (ADRBASE+count);
		
		if(count==0x0)
		{
			if(*pAddr!=((char)0xCA))
			{
				/*Result(1);*/
				break;
			}	
		}	
		
		if(mark)
		{
			if(*pAddr==((char)0x35))
			{
				/*Result(0);*/
				break;
			}
			
			mark = 0;
		}
		
		if(*pAddr==((char)0x53))
		{
			mark = 1;
		}
	}

	return (count-2);
}

int fgetc_rbf( int finputid )
{
	pAddr = pfpointer;
	pfpointer++;

	return (int) *pAddr;
}

void fclose_rbf(file_id)
{	
}

int Result(int error)
{
	int count;
	
	*pDir = 0x38;
	
	for(count=0;count<5;count++)
	{
		*pData = (error?0x20:0x38);
		Delay(10);
		*pData = (error?0x18:0x0);
		Delay(10);
	}
	
	*pDir = 0x38;
}

void WriteByteBlaster( int port, int data, int test )
{	
	/* Only Port 0 is taken care of */	
	if(!port)
		*pData = (char) data;		
}

inline asm void dump(int size)
{
	move.l #2147483648,D1
	movec.l D1,CACR
	
	move.l #258049,A0
	move.l #3936032,D0
	move.l #268435913,A1
NextByte: move.b (A0)+,(A1)
	sub.l #1,D0
	bne NextByte
}

void Burst( int file_size)
{
/*	int count;
	pAddr = (char*) (ADRBASE+1);

	for(count=0;count<file_size;count++)
	{
		*pData = (char) *pAddr++;
	}
*/
	dump(file_size);
}

int ReadByteBlaster( int port )
{
	int conf_done = 0;
	int nstatus = 0;
	int data = 0;

	data = *pData;
	
	conf_done = (data & 0x40);
	conf_done = conf_done? 0: 0x40;
	nstatus = (data & 0x80);
				
	return (conf_done | nstatus);
}





